/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.defects.web.client.OSLCRmProvider");

dojo.require("jazz.client.xhr");
dojo.require("com.ibm.team.repository.web.foundation.Status");

(function(){

    var Status = com.ibm.team.repository.web.foundation.Status;
    
    dojo.declare("com.ibm.rqm.defects.web.client.OSLCRmProvider", null, {
    
        constructor: function(serviceProvider){
            this._serviceProvider = serviceProvider;
        },
        
        /***
         * Create a new link in the RM service provider. linkDescription: {url, linkComment, rqmUrl}
         * @param {Object} linkDescription
         * @param {function} responseCallback
         */
        postLink: function(linkDescription, responseCallback){
            
        },
        
        /***
         * Delete an existing link in the RM service provider
         * @param {Object} linkDescription
         * @param {Object} responseCallback
         */
        deleteLink: function(linkDescription, responseCallback){
        },
        
        __sentinel: null // terminates this class definition
    });
})();
