//debug CopyClient
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
(function () {
	
dojo.provide("com.ibm.rqm.planning.web.client.internal.CopyClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");


var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

com.ibm.rqm.planning.web.client.internal.CopyClient = {
	COPY_REST_SERVICE_URI : "com.ibm.rqm.process.deployment.rest.ICopyRestService",
	_invokeService: function(responseHandler, method, appArgs) {
	
		var serviceRequest= new ServiceRequest(this.COPY_REST_SERVICE_URI, method, appArgs);
		return TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	postCopyItemsAsynch: function(serviceResponseHandler, args) {
		return this._invokeService(serviceResponseHandler, "postCopyItemsAsynch", args);
	},
	
	getStatus: function(serviceResponseHandler, args) {
		return this._invokeService(serviceResponseHandler, "getStatus", args);
	},
	
	postCorrelate: function(serviceResponseHandler, args) {
	    return this._invokeService(serviceResponseHandler, "postCorrelate", args);
	},
	
	postCancel: function(serviceResponseHandler, args) {
        return this._invokeService(serviceResponseHandler, "postCancel", args);
    }
};
	
})();

