/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
// author: Paul Beaulieu
//
// Summary: This is a widget to choose options.
//

dojo.provide("com.ibm.asq.common.web.ui.internal.util.PropertyAdder");

(function() {
dojo.declare(
    "com.ibm.asq.common.web.ui.internal.util.PropertyAdder",
    null,
{
	addProperties: function( jsObject, properties )
	{
		for( var property in properties )
		{
			if( jsObject )
			{
				jsObject[ property ] = properties[ property ];
			}
		}
	}
}
);
})();

