/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
var ReportUtil = dojo.provide("com.ibm.rqm.reports.web.ui.internal.util.ReportUtil");

(function() {
    var REPORT_URI = "#action=com.ibm.rqm.planning.home.actionDispatcher&subAction=viewReport";
    var REPORT_URI_QUERY_PARAM = "&queryUUID=";
    var REPORT_URI_REPORT_PARAM = "&reportUUID=";
	var REPORT_ID_REPORT_PARAM = "&reportId=";
    var REPORT_URI_NAME_PARAM = "&name=";
		
	com.ibm.rqm.reports.web.ui.internal.util.ReportUtil = {
		getReportURI: function(query) {        
            //console.debug("_getReportURI: " + this.declaredClass + " : " + REPORT_URI);                  
            //var query = this._getQueryForReport(report.reportUUID);
            var uri = REPORT_URI + REPORT_URI_NAME_PARAM + encodeURI(query.name);            
            if (query.queryUUID) {
                uri += REPORT_URI_QUERY_PARAM + query.queryUUID;        
            } else {
                uri += REPORT_URI_REPORT_PARAM + query.reportUUID;
            }
			if (query.reportId) {
				uri += REPORT_ID_REPORT_PARAM + query.reportId;
			}
            return uri;             
        }		
	};
}
)();
