//SOS
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.SequenceOverviewSection");
dojo.provide("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.SequenceOverviewSection");
/*
 * author: vasrivas
 */
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.core.loader");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditorSection");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.datetimepicker.DateTimePicker");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.TestCellTableView");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("dijit.form.CheckBox");
(function() {
	var AbsractEditorSection 				= com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditorSection;
	var Constants 							= com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants;
	var ServiceResponseHandler				= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var SelectUtility 						= com.ibm.asq.common.web.ui.internal.util.SelectUtility;
	var ImageCache 							= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
dojo.declare("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.section.SequenceOverviewSection", [dijit._Widget, dijit._Templated, AbsractEditorSection],
{
		templatePath: dojo.moduleUrl("com.ibm.rational.test.lm.sequencer.web", "ui/internal/view/templates/section/SequenceOverviewSection.html"),
		
		labelTimeBasedScheduling: Constants.getMessage("labelTimeBasedScheduling"),
		labelBVTSchedule: Constants.getMessage("labelBVTSchedule"),
		labelSelectBuild: Constants.getMessage("labelSelectBuild"),
		labelStartExcSchOn: Constants.getMessage("labelStartExcSchOn"),
		labelTestCell: Constants.getMessage("labelTestCell"),
		labelSelectTestCell: Constants.getMessage("labelSelectTestCell") + Constants.getMessage("labelColen"),
		labelDate:Constants.getMessage("labelDate"),
        labelClear:Constants.getMessage("labelClear"),
		
		testCellItemId: null,
		testCell: null,
		
		postCreate: function(){		
			this._initialized = false;
			this._itemsToTrack = {};
			this._itemsToTrack.buttons = [];
		},
		
		initialize: function(){
			dojo.deprecated("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditorSection is deprecated and will be removed post 2.0");
			this.timeRadio = new dijit.form.RadioButton({value:"table",checked:true,name:"defaultViewMode"});
			this.timeRadio.style.marginRight="4px";
			this.connect(this.timeRadio, "_clicked", "timeClicked");
			this._timeBased.appendChild(this.timeRadio.domNode);
			this._itemsToTrack.buttons.push(this.timeRadio);
			
			this.eventRadio = new dijit.form.RadioButton({value:"table",checked:false,name:"defaultViewMode"});
			this.eventRadio.style.marginRight="4px";
			this.connect(this.eventRadio, "_clicked", "eventClicked");
			this._eventBased.appendChild(this.eventRadio.domNode);
			this._itemsToTrack.buttons.push(this.eventRadio);
			
			var parentEditor = this.getParentEditor();
			var artifact = parentEditor.getArtifact();
			
			if(parentEditor.getSequenceType() == Constants.SEQUENCE_TYPE_BVT){
				this.timeRadio._setCheckedAttr(false);
				this.eventRadio._setCheckedAttr(true);
			}else{
				this.eventRadio._setCheckedAttr(false);
				this.timeRadio._setCheckedAttr(true);
			}
			var now = null;
			if(artifact && artifact.scheduledStart){
				now = new Date();
				now.setTime(artifact.scheduledStart);
			}else{
				now = new Date();
			}
			
			this.datePicker = new com.ibm.asq.common.web.ui.internal.widgets.datetimepicker.DateTimePicker({
					date: now,
					time: now,
					onDateChange: dojo.hitch(this, "_onChange"),
					onTimeChange: dojo.hitch(this, "_onChange")
				});
				this.datePicker.labelNode.style.display = "none";
				this.timerDiv.appendChild(this.datePicker.domNode);
			
			this._clearCell.src = ImageCache.CLEAR_FILTER_ENABLED;
			this._changeCell.src = ImageCache.TEST_CELL;
			this._changeCell.title = this._changeCell.alt = Constants.getMessage("labelSelectTestCell");
			this._clearCell.title = this._clearCell.alt = Constants.getMessage("labelClear");
			this._changeCell.style.cursor = "pointer";
			this._clearCell.style.cursor = "pointer";
			if(!dojo.getObject("com.ibm.rqm.buildintegration.web.client.internal.build.BuildClient")){
				jazz.core.loader.load_async("com.ibm.rqm.buildintegration.web.client.internal.build.BuildClient", dojo.hitch(this, "_getBuildDefinations"));
			}else {
				this._getBuildDefinations();
			} 
			if(!dojo.getObject("com.ibm.rational.test.lm.web.client.internal.collections"))
				jazz.core.loader.load_async("com.ibm.rational.test.lm.web.client.internal.collections", function(){});
			this._updateStatusDD([{name: Constants.getMessage("labelBuildSuccess"), id:"completed"}, {name: Constants.getMessage("labelBuildError"), id:"error"}]);
			if(artifact && artifact.testCellItemId){
				this.testCellItemId = artifact.testCellItemId;
				this._loadTestCell(artifact.testCellItemId);
			}else{
				this.changeCellEvent = this.connect(this._testCellName, "onclick", dojo.hitch(this, this._onChangeTestCell));
				this._testCellName.style.cursor = "pointer"; 
			}
			this._keyPressCell = null;
			this._keyPressClear = null;
			this._keyPressCell = this.connect(this._changeCell, "onkeypress", this._onKeyPressCell);
			this._keyPressClear = this.connect(this._clearCell, "onkeypress", this._onKeyPressClear);
			
			this._initialized = true;	
		},
		
		_onKeyPressCell: function(e){
			var charCode = (e.which) ? e.which : e.keyCode;
			if (charCode == 13) {
				this._onChangeTestCell();
			}
		},
		
		_onKeyPressClear: function(e){
			var charCode = (e.which) ? e.which : e.keyCode;
			if (charCode == 13) {
				this._onClearTestCell();
			}
		},
		_getBuildDefinations: function(){
			SelectUtility.add( this._selectBuild, new Option(Constants.getMessage("labelLoading"), "-1") );
			var responseHandler = new ServiceResponseHandler(this, "_fillBuildInfo", "_error");  
			com.ibm.rqm.buildintegration.web.client.internal.build.BuildClient.getBuildDefinitionsDTO(responseHandler, {});
		},
		
		_fillBuildInfo: function(builds){
			dojox.data.dom.removeChildren(this._selectBuild);
			var builds = builds ? builds : [{name: Constants.getMessage("labelUnassigned"), id: "-1"}];
			var selectedBuildId = null;
			var artifact = this.getParentEditor().getArtifact();
			if(artifact && artifact.associatedBuildDef){
				selectedBuildId = artifact.associatedBuildDef.id;
			}
			var buildsLength = builds.length;
			for (var i = 0; i < buildsLength; i++){
				var build = builds[i];
				var option = new Option(build.name, build.id);
				if(build.id == selectedBuildId)
					option.selected = true;
				SelectUtility.add( this._selectBuild, option );
			}
			this.connect(this._selectBuild, "onchange", "_onChange");
		},
		
		_updateStatusDD: function(status){
			if(status && status.length){
				var selected = "completed";
				var artifact = this.getParentEditor().getArtifact();
				if(artifact && artifact.runOnFailedBuild){
					selected = "error";
				}
				var statusLength = status.length;
				for(var i=0;i<statusLength;i++){
					var opt = new Option (status[i].name, status[i].id);
					if(status[i].id == selected)
						opt.selected = true;
					SelectUtility.add(this._selectExecOn, opt);
				}
			}
			this.connect(this._selectExecOn, "onchange", "_onChange");
		},
		
		_onChange: function(){
			if(this._initialized)
				this.setDirty(true);
		},
		
		//Over-ridden from _AES
		validate: function(){
			return true;
		},
		
		//Over-ridden from _AES
		getAttributes: function(){
			var attributes = {
			}
			return attributes;
		},

		getScheduledTime: function(){
			return this.datePicker.getValue().getTime();
		},
		
		getBuildUUID: function(){
			return (this._selectBuild.value != "-1" ? parseInt(this._selectBuild.value) : null);
		},

		isRunOnFailedBuild: function(){
			return this._selectExecOn.value == "error" ? true : false;
		},
		//Over-ridden from _AES
		saveFinished: function(){
			
		},
		//Over-ridden from _AES
		saveError: function(){
			
		},
		
		eventClicked: function(e){
			this.parentEditor.setSequenceType(Constants.SEQUENCE_TYPE_BVT);
			this.setDirty(true);
		},
		
		timeClicked: function(e){
			this.parentEditor.setSequenceType(Constants.SEQUENCE_TYPE_SCHEDULE);
			this.setDirty(true);
		},
		
		_onChangeTestCell: function(){
			//bring up Test cell selection dialog.
			 var dialogArgs = {
		            okCallback: dojo.hitch(this, "_testCellSelected"),
		            cancelCallback: dojo.hitch(this, "_cancelled"),
					isClosable: true
		        };
			
			this.cellTableView = new com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.TestCellTableView({});
			this.cellTableView.initialize();
			
			var testCellDialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
			//Make the OK button available to the table so it can enable/disable it based on row selection
			this.cellTableView.OKButton = testCellDialog.getOkButton();
			testCellDialog.contentContainer.appendChild(this.cellTableView.domNode);
			testCellDialog.setWidth("80%");
	        testCellDialog.setHeight("80%");
			testCellDialog.setSecondaryTitle(Constants.getMessage("labelSelectTestCell"));
			testCellDialog.open();
		},
		
		_testCellSelected: function(){
			this._clearCell.src = ImageCache.CLEAR_FILTER_ENABLED;
			this._testCellName.style.color = "gray";
			this.disconnect(this.changeCellEvent);
			this._testCellName.style.cursor = "default";
			this.changeCellEvent = null;
			var item = this.cellTableView.getSelectedItem();
			if(item && item.length == 1){
			    this.setDirty(true);
				//Load the Test Cell
				this.loadTestCell(item[0].itemId);				
			}
		},
		
		_cancelled: function(){
			//Do nothing	
		},
		
		_onClearTestCell: function(){
			//clear selection
			this._testCellName.innerHTML = Constants.getMessage("labelUnassigned");
			this._testCellName.style.color = "#1E9494";
			this.testCellItemId = null;
			this.testCell = null;
			this._clearCell.src = ImageCache.CLEAR_FILTER_DISABLED;
			this._changeCell.style.cursor = "pointer";
			this.setDirty(true);
			this.disconnect(this.changeCellEvent);
			this.changeCellEvent = this.connect(this._testCellName, "onclick", this._onChangeTestCell);
			this._testCellName.style.cursor = "pointer";
		},
		
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from SequenceOverviewSection#_error");
		},		
		
		loadTestCell: function(cellID){
	        var responseHandler = new ServiceResponseHandler(this, "_loadCellSuccess", "_loadCellFailure");
    		var cellService = new com.ibm.rational.test.lm.web.client.internal.collections();
			cellService.getTestCell(responseHandler, cellID);
		},
		
		_loadCellSuccess: function(response){
			this.testCell = response;
			this.testCellItemId = response.itemId;
			this._testCellName.innerHTML = response.name;			
		},
		
		getCellObject: function(){
			return this.testCell;
		},
		
		uninitialize: function(){
			var buttons = this._itemsToTrack.buttons;
			var buttonLength = this._itemsToTrack.buttons.length;
			for(var i=0;i<buttonLength;i++){
				buttons[i].destroy();
			}
		},
		
		_loadCellFailure: function(response){
			//What to do here?
		}
	}
);
}
)();
		
