//SequenceResultPage
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceResultsPage");
dojo.provide("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceResultsPage");
/*
 * author: vasrivas
 */
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditor");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants");
dojo.require("com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient");
dojo.require("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceResultTableView");
(function() {
var ServiceResponseHandler		   	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var AbstractEditor 					= com.ibm.rational.test.lm.sequencer.web.ui.internal.view.common._AbstractEditor;
var Constants 						= com.ibm.rational.test.lm.sequencer.web.ui.internal.Constants;
var SequenceClient					= com.ibm.rational.test.lm.sequencer.web.client.internal.sequence.SequenceClient;
var SequenceResultTable 	= com.ibm.rational.test.lm.sequencer.web.ui.internal.view.table.SequenceResultTableView;
dojo.declare("com.ibm.rational.test.lm.sequencer.web.ui.internal.view.sequence.SequenceResultsPage", [dijit._Widget, dijit._Templated, AbstractEditor],
{
		templateString: "<div>" +
						"    <div dojoType=\"com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout\" dojoAttachPoint=\"_header\"" +
                	    "         summaryAsDesc=\"true\">" +
						"<div dojoAttachPoint=\"topSection\"></div>"+
						"<div dojoAttachPoint=\"tableSection\"></div>"+
						"</div>"+
						"</div>",
		widgetsInTemplate: true,
		sequenceId: null,
		
		postCreate: function(){
			this.initialize();
		},
		
		initialize: function(args){
			this.sections = [];
			this.setReadOnly(true);
			this.createHeader({title: Constants.getMessage("labelExecutionSequenceResults")
												, iconClass: "sequence-result-def-icon-48", nonEditable: true,
												csHelpId: "sequence_result_listing.html"});
			this.seqResultTableView = new SequenceResultTable({parentEditor: this});
			var sequenceId = null;
			if(this.sequenceId){
				sequenceId = this.sequenceId; 
			}
			this.seqResultTableView.initialize({queryName: null, sequenceId: sequenceId});
			var resultTableSection = this.createSection(this.tableSection, {title: Constants.getMessage("labelResults"), widget: this.seqResultTableView, 
									csHelpId: "sequence_result_listing_detail.html"});
		},
		
		getTabClass: function(){
			return "sequence-result-icon-16-inTab";
		},
		
		onSave: function(){
			
		},
		
		onDiscard: function(){
			
		},
		
		onArtifactChanged: function(changeType, artifactType, artifactArray) {
			if(this.seqResultTableView)
				this.seqResultTableView.onArtifactChanged(changeType, artifactType, artifactArray) ;
		},
		
		_error: function(errorObj){
			console.error("Error: (message: '" + errorObj.message + "') from SequenceResultsPage#_error");
		}
	}
);
}
)();
		
