//debug CopyClient
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
(function () {
	
dojo.provide("com.ibm.rqm.planning.web.client.internal.QueryableProjectArea");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");


var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

com.ibm.rqm.planning.web.client.internal.QueryableProjectArea = {
	PERMISSION_REST_SERVICE_URI : "com.ibm.rqm.process.deployment.rest.IPermissionRestService",
	_invokeService: function(responseHandler, method, appArgs) {
		var serviceRequest= new ServiceRequest(this.PERMISSION_REST_SERVICE_URI, method, appArgs);
		return TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	getInitialProjectAreas: function(serviceResponseHandler, args) {
		return this._invokeService(serviceResponseHandler, "getInitialProjectAreas", args);
	},
	
	getSomeProjectAreas: function(serviceResponseHandler, args) {
		return this._invokeService(serviceResponseHandler, "getSomeProjectAreas", args);
	},
	
	getScopedPropertyAreasURL: function(args) 
	{
		return  "/service/com.ibm.rqm.process.deployment.rest.IPermissionRestService/scopedProjectAreas?itemTypeName=VersionedTestPlan&itemTypeNSUri=com.ibm.rqm.planning&namePrefix=abc"
	},
	
	getScopedProjectAreas: function(serviceResponseHandler, args) {
		return this._invokeService(serviceResponseHandler, "getScopedProjectAreas", args);
	}
};
	
})();

