/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.client.internal.mapper.AbstractMapper");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.declare("com.ibm.asq.common.web.client.internal.mapper.AbstractMapper",
             com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper, {
			 	
	doCallback: function(objs) {
        //map objects
		var mappedObjects = this.mapArray(objs);

		//this.inherited(mappedObjects);   doesn't work?!
		var obj= this._contextObject;
		obj[this._callbackName].call(obj, mappedObjects);
	},

    //map multiple objects
	mapArray: function(objArray) {
		objArray = objArray || [];
        var mappedObjects = [];
        if (objArray != null && objArray.length) {
            for (var i=0; i<objArray.length; i++) {
                var mappedObject = this.map(objArray[i]);
                mappedObjects.push(mappedObject);
            }
        }
		return mappedObjects;		
	},

	// @override
	map: function(obj) {
		return {};
	}
	
});