/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
/*
*
*	This class will be the base class for raw http services
*
*/
(function() {
dojo.require("com.ibm.asq.common.web.client.internal.api");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.asq.common.web.client.internal.container");

dojo.provide("com.ibm.rational.test.lm.web.client.internal.rawContainer");

//
//extends the api so that it has access to global vars like the server url
//

dojo.declare("com.ibm.rational.test.lm.web.client.internal.rawContainer", 
			  com.ibm.asq.common.web.client.internal.container, 
		
		
		{
		constructor: function(){
			//Superclass seems to be autoconstructed.
			//console.debug("rawContainer constructed");
		},
		/*
		*	This function can be used to create an entity.
		*/
		
		/*
		 * (non-API, do not use)
		 *
		 * Returns the correct service prefix based on the browser's security
		 * context (e.g. http or https).
		 */
		_getSecureOrPublic: function() {
			var regex= /^https/;
			return (location.href.match(regex) === null) ? "public" : "secure";
		}
});
})();
