/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
//

//

({"machDtlTitle": 			"Machine Details", 
  "machDtlOS": 				"Operating System", 
  "machDtlManufacturer": 	"Manufacturer",
  "machDtlProc": 			"Processor Type",
  "machDtlMemory": 			"Memory (MB)",
  "machDtlID": 				"ID",
  "machDtlPopHostname":     "Populate hostname with name",

  "Automate": "Automate",
  "Name": "Name",
  "appTitle":			"Rational Test Lab Manager",
  "appInfocenterHelp": "Help",
  "appAbout": "About",
  "appCopyright": "Copyright by IBM Corp. All Rights Reserved.",
  "appVersion": "Version: %1",
  "appfailGetVersion": "Failed to retrieve version number.",
  "appWorking" : "Loading...",
  "editorWorking": "Working...",
  "newLabel" : "Create",
  "selectLabel" :"Select",
  "labelPreview": "Preview",
  "unknownError": "Unknown error.",
  
  "buttonLabelOK": "OK",
  "RemoteConnectivity-section": "Remote Connection",
  "RemoteConnectivitySelector": "Remote Connection", 
  "ImageStorage-section":  "Image Storage",
  "ImageStorageSelector":  "Image Storage",  
  "labActnCrtMach": "Create Machine",
  "ID":				"ID",
  "Processor Type":	"Processor Type",
  "Operating System":"Operating System",
  "Host Name": "Host Name",
  "IP Address": "IP Address",
  "Memory":			"Memory (MB)",
  "Model":          "Model",
  "ResultsSummary": "Results from a search",
  "MachTitleMachine": "Machine",
  "MachTitleResources": "Resources",
  "MachLabelMemory":    "Memory (MB)",
  "MachLabelSearch":    "Search",
  "MachLabelIp":        "IP Address",
  "MachLabelHostname":  "Hostname",
  "MachLabelStatus":    "Machine Status",
  "MachLabelOwner":    "Owner",
  "MachLabelNewMachine":   "Create Machine",
  "MachLabelReservations": "Reservations",
  "MachLabelHistory": "History",
  "MachLabelTime": "Date Performed",
  "MachLabelEventDescription": "Event",
  "MachLabelUserid": "By",
  "MachTitleSearch" : "Find Lab Resource",
  "MachTitleAll": "All Lab Resources",
  "MachTitleArchived": "All Deleted and Hidden Lab Resources",
  "statusNoEditDeleted": "Cannot Edit a Deleted Lab Resource",
  "statusNoEditDeletedDetails": "<b>Details:<\/b><br>The Lab Resource is currently in deleted state. You cannot edit it.",
  "invalidSearchDateRange": "The specified date range is invalid",  
    
  //Search Date Strings
  "srchTypeLabel": "Lab Resource Type:",
  "srchFrom": "From",
  "srchTill": "Until",
  "srchIncludeDates": "Include dates in search",
  "srchLabel": "Find Lab Resources",
  "srchReserveLabel": "Reserve",
  "srchUnreserveLabel": "Cancel Reservation",
  "srchWorking": "Searching...",
  "srchCriteriaInfo": "Refine the search criteria by editing the criteria list, or by selecting a predefined Lab Resource Description.", 
  "srchCriteriaInfoSelOnly": "Refine the search criteria by selecting a predefined Lab Resource Description",
  
  "saveNewReminderMsg": "New / Not Yet Saved",
  "saveChangeReminderMsg": "Modified / Not Yet Saved",
  "savedSuccessMsg": "Saved successfully at: %1",
  "saveFailedMsg": "Save failed at: %1",

  "labelViewBuilder": "View Builder",
  "labelReset": "Reset",
  "labelRun": "Run",

  "MsgInvalidMemoryInput": "The value must be a number in MB",
  "MsgInvalidInput": "Please fix the invalid input before submitting.",
  "MsgMachineRequiredFields": "Either hostname or IP address must not be empty. Please enter valid values before submitting.",
  "MsgSearchWorking": "Searching for machines...",
  "MsgClearEditing": "This will clear all entered values. Continue?",
  "MsgAddingMachine": "Creating new machine...",
  "MsgNewMachineAdded": "New machine was created successfully.",
  "MsgAddMachineFailed": "Unable to create the new machine.",
  "MsgEditMachineFailed": "Unable to update the machine information.",
  "MsgInvalidHostnameInput": "The hostname must consist of alphanumeric characters and allow dot (.), dash (-), or underscore (_) in between.",
  "MsgInvalidIpInput": "The IP address must be in the format of four groups of number from 0 to 255 separated by dot (.) for IPv4, or eight groups of four hexadecimal digits separated by colon (:) for IPv6.",
  "MsgFetchMachineDetailFailed": "Unable to get information about the machine.",
  "MsgMachineUpdated": "The machine information was updated successfully.",
  "MsgUpdateMachineWorking": "Updating the machine information...",
  "MsgEditMachineFailed" : "Unable to update the machine information.",
  "MsgDiscardDiscoveredData": "Discard the discovered data?",
  "MsgUnsaveNewMachineData": "This will cancel the create machine operation and the editing you've done will be gone. Continue?",
  "MsgNeedHostOrIp": "Either hostname or IP address must be specified.",
  "MsgDiscoveryRunning": "Running machine discovery...",
  "MsgDiscoveryCompleted": "Machine discovery completed.",
  "msgRequiredValueNotPresent" : "There are required fields with no value entered.",
  "msgErrorValuesPresent" : "There are incorrect values entered.",
  "msgInvalidValue": "The value entered is not valid",
  "msgAttrInvalidChar" : "The value entered contains an invalid character.",
  "msgAttrNonNumericChar" : "Only digits (1,2,3,...9) are allowed.",  
  "msgAttrInvalidSequence": "The value entered contains segments that are out of sequence",
  "msgAttrDupOps": "The value entered contains duplicated operators with the same type.",
  "msgAttrDisjoined": "The value entered is a disjointed pattern with no result.",
  "msgAttrIncomplete": "The value entered is a incomplete sequence.",
  "msgAttrExtraComp": "The value entered has too many search components.",
  "msgAttrInvalidDiskSpaceRange": "The total disk size cannot be smaller than the free disk size.",  
  "msgCheckDates": "Please verify that the search dates are not empty and that the Available From date preceeds the Available Until date.",
  "msgReserveMachineFailed" : "Unable to reserve the machine",
  "msgUnReserveMachineFailed" : "Unable to cancel the machine reservation",
  "msgReserving": "Reserving...",
  "msgUnReserving": "UnReserving...",
  "msgReserveMachineFailedMaybeReserved" : "Unable to reserve the machine, it may already be reserved",
  "msgNumberOutOfRange": "%1 is not a valid entry.",  

  "msgFetchHideDeletedError": "Uable to retrieve lab resources.",
  "msgDeletingResources": "Deleting resources...",
  "msgHidingResources": "Hiding resources...",
  "msgRestoringResources": "Restoring resources...",
  "msgErrorDeletingResources": "Unable to delete selected resources.",
  "msgErrorHidingResources": "Unable to hide selected resources.",
  "msgErrorRestoringResources": "Unable to restore selected resources.",
  "msgSuccessDeletingResources": "Deleted resources successfully.",
  "msgSuccessHidingResources": "Hide resources successfully.",
  "msgSuccessRestoringResources": "Retored resources successfully.",
  "msgConfirmTitle": "Confirmation",
  "msgConfirmDeleteResources": "Selected %1 Lab Resource(s) will be deleted! Continue?",
  "msgConfirmHideResources": "Hide selected %1 Lab Resource(s)?",
  "msgConfirmRestoreResources": "Restore selected %1 Lab Resource(s)?",
  "msgErrorDeleteOrHideReservedResource" : "Selected Lab Resource(s) contain reservations. Please cancel pending reservations before deleting or hiding.",
  
  "viewMachine-delete": "Deleted Machines",
  "viewMachine-hide": "Hidden Machines",
  "viewVirtualImage-delete": "Deleted Virtual Images",
  "viewVirtualImage-hide": "Hidden Virtual Images",
  
  "labelDiscoverButton" : "Discover",
  "labelCancelButton" : "Cancel",
  "labelSaveButton" : "Save",
  "labelDeleteButton" : "Delete",
  "labelRemoveButton" : "Remove",
  "labelEditButton" : "Edit",
  "labelCreateButton" : "Create",
  "labelRefreshButton" : "Refresh",
  "labelCopyButton" : "Copy",
  "labelHideButton" : "Hide",
  "labelRestoreButton" : "Restore",
  
  "CopyOf": "Copy Of %1",
  
  "symbolHelp": "?",
  "labelHelp": "Help",
  "MsgFailGetHelpContent": "Sorry, unable to find the help content.",

  "navHome": "Home",
  "navMach": "Machines",
  "navReports": "Reports",
  "navRequests": "Requests",
  "navUsers": "Users",
  "navSystem": "System",
  "navAutomations":"Automations",
  "navReservations":"Reservations",
  
//  "toolImportMach": "Import Machine(s)",
  "toolFindMach": "Find Machines",
  "toolAddMach": "Add Machine",
  "moreActionsButtonLabel": "More Actions",
  
  "impPrompt_asset": "Select the XML file with the lab resource information:",
  "impPrompt_schema": "Select the XML file of the lab resource template:",
  "impMachImport": "Import",
  "impLabel_asset": "Import Lab Resources",   // this same string is in another messages.js, should be consolidated.
  "impMachUploading": "Uploading and parsing XML file...",
  "impSuccess_asset": "Import has completed. %1 resource(s) imported successfully.",
  "impSuccess_schema": "Import has completed successfully.",
  "impMachCancel": "Import request canceled",
  "impMachTimeout": "Import request timed out",
  "impMachFailed": "<b>Import failed: <\/b> Unexpected error happened. Please contact with the server admin.",
  "impMachFailed-1": "<b>Import failed: <\/b> Your file does not exist or is empty.",
  "impMachFailed-2": "<b>Import failed: <\/b> The file selected for import is not a valid xml file.",
  "impMachFailed-3": "<b>Import failed: <\/b> The file selected for import does not have the proper format. Please check with the online documentation for correct formatting.",
  "impMachFileNotXML": "The selected file \"%1\" does not have the XML file extension. Continue the import anyway?",
  "impMachStatus": "Import has completed. %1 resource(s) imported successfully.",
  "impMachCloseMsg": "Close when complete.",
  "impMachCloseButton": "Close",
  "impMachTooltip": "Please make sure the selected file path's length is no longer than 255 characters.",
  "impStatus-0" : "The import task is queued for processing.",
  "impStatus-1" : "Parsing file...",
  "impStatus-2" : "Importing... %1 of %2 resource(s) imported.",
  "impStatus-3" : "The file imported is empty or does not exist",
  "impStatus-4" : "Import failed. The file imported is not a valid xml file.",
  "impStatus-5" : "Import failed. The file imported does not conform to the appropriate schema.",
  "impStatus-6" : "Import completed. %1 of %2 resource(s) imported successfully.",
  "custTitle" : "Customize Catalog",
  "custSummary" : "Add instances of CPUs, Operating Systems, or Software",
  "custSuccess" : "Success",
  "custFailed" : "Failed",
  "custAddSucceeded" : "Successfully added %1 to the catalog",
  "custAddFailed" : "Failed to add %1 to the catalog.  There may be another entry with the same name",
  "custTypes" : "Select the type of item to add",
  "custParent" : "Select a parent for the new item",
  "custEnterValue" : "Specify a new value to add",
  
  "adminHmLabelRefresh": "Refresh",
  "adminHmSearchOffMachines": "Searching for unavailable machines...",
  "adminHmOfflineMachines": "Unavailable Machines",
  "adminHmFailGetMachines": "Unable to get the unavailable machines",
  "adminHmFailGetJobs": "Unable to get job status",
  
  "userHmMyReservations": "My Reservations",
  "userHmSearchReservations": "Searching for reservations...",
  "userHmFailGetMyReservations": "Unable to get reservations",
  "msgUnableCancelReservations": "Unable to cancel reservations.",
  
  "userHmMyRequests": "My Requests",
  "userHmSearchRequests": "Searching for requests...",
  "userHmFailGetMyRequests": "Unable to get requests",
  "userHmNoRequest": "This reservation does not have an associated request.",
  
  "userCurrent": "Welcome %1",
  "userGetInfo": "Getting user info...",
  "userUnknown": "Unknown user",
  "userLoginfailed": "Authentication Failed",
  "userNotLoggedIn": "User is not logged in - unable to retrieve user information.",

  "time": "Date Performed",
  "eventDescription": "Event",
  "userid": "By",
  
  "MsgJobRetrievalSucceeded": "Retrieval of automation scripts has succeeded.",
  "MsgJobRetrievalFailed": "Failure retrieving automation scripts.",
  "MsgJobRanOK": "Job has been queued to run.",
  "MsgJobFailure": "Job has not been queued to run.",
  
  "MsgHistoryRetrieval": "Retrieving Machine History",
  "MsgHistoryRetrievalSucceeded": "Retrieval of Machine History has succeeded",
  "MsgHistoryRetrievalFailed": "Retrieval of Machine History has failed",
  
  // button labels
  //
  "reset_button": "Discard",
  "save_button": "Save",
  "submit_button": "Submit",
  "close_button": "Close",
  "return_button": "Return",
  "fulfill_button": "Fulfill",
  "cancel_button": "Cancel Request",
  "reopen_button": "Reopen",
  "discard_button" : "Discard Changes",
  "add_attribute": "Add Criteria",
  
  //Request table messages
  "reqId": "ID",
  "reqSummary": "Summary",
  "reqCreated": "Created",
  "reqNeedBy": "Respond By", // respond by a specified date
  "reqAssignedTo": "Assigned To",
  "reqStatus": "Status",
  "reqPriority": "Priority",
  "request_view_label": "Show: ",
  "reqMsgRetrievingRequestsWorking": "Retrieving requests...",
  
  //These cannot have req prefix because they come from the database this way.
  "all unassigned": "All Unassigned",
  "all assigned": "All Assigned",
  "assigned to me": "All Assigned to Me",
  "my submitted": "My Submitted",
  "my fulfilled": "My Fulfilled",
  "fulfilled by me": "Fulfilled by Me",
  "my closed": "My Closed",
  "my open": "My Open Requests",
  "Low": "Low",
  "Normal": "Normal",
  "High": "High",
  "Urgent": "High",
  "my current reservations": "My Active Reservations",
  "my future reservations": "My Future Reservations",
  "my reservations": "All My Reservations",
  "all reservations": "All Reservations",
  "Draft": "Draft",
  "Submitted": "Submitted",
  "Assigned" : "Assigned",
  "Fulfilled" : "Fulfilled",
  "Returned" : "Returned",
  "Closed" : "Closed",
  "Canceled" : "Canceled",
  
  // request form labels/messages
  //
  "reqLabel_id_display": "(ID: %1)",
  "reqLabel_resubmit_button": "Resubmit",
  "reqLabel_request": "Request",
  "reqLabel_requests": "Requests",
  "reqLabel_new_request": "Request &lt;%1&gt;",
  "reqLabel_status_type": "Draft",
  "reqLabel_summary_editable": "Description: *",
  "reqLabel_summary": "Summary:",
  "reqLabel_status": "Status:",
  "reqLabel_reserve": "Reserve:",
  "reqLabel_details": "Details",
  "reqLabel_reservation": "Reservation",
  "reqLabel_from": "From:",
  "reqLabel_to": "To:",
  "reqLabel_type": "Type:",
  "reqLabel_priority": "Priority:",
  "reqLabel_created_on": "Created:",
  "reqLabel_created_by": "Created by:",
  "reqLabel_requested_for": "Requested For:",
  "reqLabel_project": "Project:",
  "reqLabel_config": "Lab Resources",
  "reqLabel_assigned": "Assigned to:",
  "reqLabel_unassigned": "Unassigned",
  "reqLabel_confirm_by": "Respond by:",
  "reqLabel_notify": "Notify:",
  "reqLabel_discussion": "Discussion",
  "reqLabel_description": "Description",
  "reqLabel_comments": "Comments",
  "reqLabel_addConfig": "Add Test Environment",			// CML: term
  "reqLabel_FindMachines": "Find Machine(s)",
  "reqLabel_removeConfig": "Remove Test Environment",	// CML: term
  "reqLabel_machineConfigDesc": "Select attributes, operators and values for this machine configuration.",
  "reqLabel_reserveMachine": "Reserve",
  "reqLabel_addParam": "Add Another Attribute",
  "reqMsgDateInputFormat": "Please enter a valid date",
  "reqMsgPerformRequestAction": "Performing the request action...",
  "reqMsgInvalidDateRange": "The entered reservation date range is invalid.",
  "reqMsgConfirmUnassign": "The request is assigned. You have cleared the Assignee. The request will revert back to submitted. Continue?",
  "reqMsgRequestActionSucceeded":"Request action performed successfully.",
  "reqMsgRequestActionFailedStaleData": "Error occurred. Cannot save the Request because it was edited by another user.",
  "reqMsgRequestActionFailed": "Unable to perform request action.",
  "reqMsgFetchDataError": "Unable to get request information from the server.",
  "reqMsgInvalidDateEntered": "An invalid date value has been entered.",
  "reqMsgMissingDateRange": "Both \"Reserve From\" and \"Reserve To\" dates must be specified.",
  "reqMsgRequiredValueMissing": "A Description must be entered.",
  "reqMsgFromDateError": "The \"Reserve From\" date is incorrect. Please fix it before saving/submitting", 
  "reqMsgToDateError": "The \"Reserve To\" date is incorrect. Please fix it before saving/submitting", 
  "reqMsgNeededByDateError": "The \"Respond By\" date is incorrect. Please fix it before saving/submitting", 
  "reqMsgInvalidFromDate": "The \"Reserve From\" date is in the past. Please fix it before saving/submitting.",
  "reqMsgInvalidToDate": "The \"Reserve To\" date is in the past. Please fix it before saving/submitting.",
  "reqMsgNegativeFromToDate": "The \"Reserve From\" time can not be the same or later than the \"Reserve To\" time.",
  "reqMsgInvalidConfirmDate": "The \"Respond By\" date is in the past. Please fix it before saving/submitting.",
  "regMsgNonExistDate": "The specified date does not exist.",
  "reqMsgCancelConfirm": "Canceling the request will remove it from the system. Continue?", 
  "reqMsgIncompleteAttributeWarning": "There are incomplete attributes defined in the Test Environment. They will be ignored.",		// CML: term
  "reqMsgSelectMachine": "Please select a machine to reserve",
  "reqMsgCantFindMachine": "The request does not have a reservation date range specified. Cannot search for machine for this request.",
  "machineConfigAttributeNamePrompt": "Please select an attribute.",
  "machineConfigAttributeNameError": "Invalid attribute name.",
  "machineConfigAttributeOperatorPrompt": "Please select operator.",
  "machineConfigAttributeOperatorError": "Invalid operator.",
  "machineConfigAttributeValuePrompt": "Please select attribute value.",
  "machineConfigAttributeValueError": "Invalid attribute value.",
  "reqLabel_reserveInfoText": "Enter the date range for the requested resources.",
  "reqLabel_configInfoText": "Specify the test environments for the request.",
  "reqLabel_configInfoSearchText": "Find lab resources to fulfill the specified lab resource description(s).",
  "reqLabel_commentInfoText": "Enter any additional comments about the request/resources.",
  "reqLabel_summaryPrompt": " &lt; Click here to enter description &gt; ",
  "reqMsgNoMachineFound": "No machine found that matches the Lab Resource Description criterion. Refine the criteria and find again.",
  "reqMsgNoMachineFoundErr": "Unable to find machine. A server error occurred.",
  
  "machConfigEditableDesc": "Enter attributes, operators, and values for the machine",
  "machConfigReadOnlyDesc": "Machine configuration attributes",
  "machConfigReadOnlyBlankDesc": "No specific attributes requested",
  "machConfigSelectableDesc": "Select the attributes to include in the machine search",
  "machConfigAddConfig": "Add Configuration",
  "machConfigAddParam": "Add Parameter",
  "machConfigRemoveParam": "Remove parameter",
  "machConfigErrorLabel": "ERROR",
  "machConfigAttrNotSpecifiedWarning": "The parameter \"%1\" will be ignored because its attribute is not specified. Continue?",
  "machConfigInvalidAttrValueType": "Invalid value type specified for parameter \"%1\".",
  "machConfigInvalidParamAttr": "\"%1\" is not a specified parameter attribute.",
  
  //Reservation Table Messages
  "reservedBy": "Reserved by",
  "reservedFor": "Reserved for",
  "reserveFrom": "Start Date",
  "reserveTo": "End Date",
  "MsgResRetrievalSucceeded": "Retrieval of Machine Reservations has succeeded",
  "MsgResRetrievalFailed": "Retrieval of Machine Reservations has failed",
  "reqMsgFetchDataError": "Unable to get request information from the server.",
  "resMachine": "Reserve machine",
  "resMachine24Hours": "Reserve machine for the next 24 hours",
  "unresMachine": "Cancel machine reservation",
  "resbyuntil": "by %1 until %2",
  "Reserved": "Reserved",
  
  // Userhome Reservation table strings
  //
  "resId": "ID",
  "resMachineHostname": "Machine hostname",
  "resStartDate": "Start Date",
  "resEndDate": "End Date",
  "resRequestStatus": "Request Status",
  "resRequestId": "Request ID",
  "resReservedBy": "Reserved By",
  
  
  // Reservations Page strings
  "resReservationsPageTitle": "Reservations",
  "resActiveReservationsTitle": "Active Reservations",
  "resFutureReservationsTitle": "Future Reservations",
  "resMachineName": "Machine",
  "resSelect": "Select",
  "reservations_view_label": "Show: ",
  "resMsgRetrievingReservationsWorking": "Retrieving reservations...",
  "resResLabel": "Reservation",
  "resCanceling": "Canceling Reservations....",
  "resCancelSelected" : "Cancel Selected Reservation(s)",
  "resNoPermToCancel": "No Permissions to cancel",
  "resNoPermToCancelDetails": "<b>Details:<\/b><br>You do not have permissions to cancel any, or all of the selected reservations.",
  
  //Lab Manager homepage request table strings
  "my_assigned_requests_title": "My Assigned Requests",
  "reqSubmitter": "Submitter",
  "MsgResRetrievalSucceeded": "Retrieval of Machine Reservations has succeeded",
  "MsgResRetrievalFailed": "Retrieval of Machine Reservations has failed",

  "reqMsgfindMachForCfg": "Include the following selected attributes when searching for a machine:",
  
  "!checkbox": "cb",
  "attrName": "name",
  "op": "op",
  "value": "value",
  
  "resselect": "Select",
  "reshostname": "Machine Name",
  "resreservefrom": "Reserve From",
  "resreserveTo": "Reserve To",
  
  "reqLabel_ReservedMachines": "<B>Reserved Machine:<\/B>",
  
  // Report messages
  "rptLabelNewReport": "Create report",
  "rptLabelPrint": "Print",
  "rptLabelMyReports": "My Reports",
  "rptLabelReportName": "Machines by Owner",
  "rptMsgLoading": "Loading report...",
  "rptMsgFailed": "Unable to load the report.",
  
  "MsgResNoMatchingMachines" : "No machine(s) are available on the selected dates given the selected parameters.",
  
  //  Configuration(s) messages
  "cfgCfgView": "Test Environments",												// CML: term
  "cfgMsgRetrievingConfigurationsWorking": "Retrieving Test Environments...",		// CML: term
  "cfgConfigurationsPageTitle": "Test Environments",								// CML: term
  "cfgConfigurations_view_label": "Show: ",
  "cfgName": "Name",
  "cfgDescription": "Description",
  "cfgDescriptionLabel": "Description: ",
  "cfgSummary": "Summary",
  "cfgCfgLabel": "Test Environment",												// CML: term
  "cfgUnassigned": "Unassigned",
  "cfgAllConfigsLabel": "All",
  "cfgShowQuery": "Show Query View",
  "cfgNoneLabel": "--None--",
  "cfgClearForm": "Clear Form",
  "cfgAssetDescription": "Lab Resource Descriptions",
  "cfgLabelPrompt": "Enter a label for the Lab Resource Description",
  "cfgLabelPromptResourceNumber": "Enter a label for the Lab Resource Description %1",
  "cfgAddPart" : "Add Lab Resource Description",
  "cfgAddConfig" : "Add from Test Environment...",									// CML: term
  "cfgInitFromConfig" : "Initialize from Test Environment...",						// CML: term
  "cfgNoLabel" : "No Label",
  "cfgEdit" : "Edit",
  "cfgSummary" : "Summary",
  "cfgFindMachines" : "Find Machines",
  "cfgSelectAssetForSearch": "Select Lab Resource To Search",
  "cfgDeleteResourceDescription": "Delete Lab Resource Description",
  "cfgNewPrompt" : "&lt; Enter New Test Environment Name &gt;",						// CML: term
  "cfgNewDescriptionPrompt": " &lt; Click here to enter description &gt; ",
  "cfgDelete" : "Delete",
  "select_attribute": "Select Attribute",
  "cfgRequireNameError": "You must enter a name for the Test Environment.",		// CML: term
  "cfgHasError": "There are input errors in the Test Environment.",				// CML: term
  "cfgEmptyConfig": "No Lab Resource Description specified",
  "cfgSelectLRD": "Lab Resource Description: ",
  "cfgNonameLRD": "Lab Resource Description",
  "cfgMsgConfigDeleted": "The Test Environment of this editor has been deleted",	// CML: term
  "cfgMsgActionError": "Unable to perform the action.",
   
  //Job Status table messages
  "job_status_title": "Automation Status",
  "retrievingJobStatus": "Retrieving automation status...",
  "jobId": "ID",
  "jobName": "Name",
  "jobOwner": "Owner",
  "jobMachine": "Machine",
  "jobStartTime": "Start Time",
  "jobDuration": "Duration",
  "jobEndTime": "End Time",
  "jobState": "State",
  "jobResult": "Result",
  "Pending": "Pending",
  "Unknow": " -- ", // No need to translate
  "Started": "Started",
  "Completed": "Completed",
  "jobResult": "Result",
  "Running": "Running",
  "Passed": "Pass",			// CML: term
  "Warning": "Warning",
  "Failed": "Fail",			// CML: term
  "days": "days",
  "hours": "hours",
  "minutes": " minutes",
  "seconds": " seconds",
  "msgStartAutoOp": "Initiate the automation run...",
  "ErrStartAutoOp": "Unable to initiate the automation run.",
  
  "MsgRequestMachineSearch": "Searching for machines to fulfill request...",
  "MsgReserveMachine": "Reserving machine for request.",
  
  "MsgNoMachinesHaveBeenFound": "No machines have been found that match the currently selected search parameters.",
  "MsgNoRequestsAvailable": "No requests have been found given the currently selected view.",
  "MsgNoReservationsAvailable": "No reservations have been found given the currently selected view.",
  
  //Paging messages
  "pageforward": "Next Page",
  "pagereverse": "Previous Page",
  
  //Template Initialization Messages
  "RlmInitializingTemplate" : "Initializing...",
  "RlmInitializeTemplateFailed" : "Failed to initialize properly.",
  
  // Asset page
  "newAssetPrompt" : "&lt; Enter New %1 Name &gt; ",
  "savingAsset" : "Saving the Lab Resource...",
  "savingGroup" : "Saving group...",
  "saveAssetSuccess" : "Lab Resource saved successfully.",
  "saveAssetFailed" : "Error occurred. Cannot save the Lab Resource.",
  "saveAssetFailedModifiedAsset" : "Error occurred. Cannot save the Lab Resource because it was edited by another user.",
  "fetchAssetFailed" : "Unable to get information about the Lab Resource.",
  "confirmDiscard": "Changes made since last save will be lost! Continue?",
  "confirmDiscardTitle": "Discard Changes Confirmation",
  "machineGroupUnknown": "Unknown",
  "resourceGroupInfoFailure": "Failed retrieve lab resource group info.",
  "resourceAddedToGroupFailed": "Failed add asset to group.",
  "resourceGroupInfoFailure": "Failed retrieve lab resource group info.",
  "confirmReleaseResourceFromGroup": "Are you sure you want to release the lab resource from its group?",
  "releasingLabResource": "Releasing lab resource...",
  "resourceReleased": "Lab Resource is released back to the pool successfully.",
  "resourceReleaseFailed": "Failed to release the lab resource.",
  "failedLookupAssets": "Error occurred. Unable to look up lab resources.",
  "unknownOsDisplay": "< Unspecified >",  // please unprotect this string and translate "Unspecified"
  "labelUnspecified": "Unspecified",
  
  "newVirtualImage" : "Create Virtual Image",
  "VirtualMachine" : "Virtual Machine",
  "VirtualMachines": "Virtual Machines",
  "newMachine" : "Create Machine",
  "Machines" : "Machines",
  "machineInGroup" : "In Group: ",
  "machineNoGroupMembership": "None",
  "VirtualImage.name": "Image Name",
  "labelCapitalNew": "New",
  "labelColen": ":",
  "labelManagedVirtualImage": "Managed Virtual Image",
  "labelManagedVirtualMachine": "Managed Virtual Machine",
  
  "machinesection" : "Machine",
  "cpu-section": "CPU",
  "ossection" : "Operating System",
  "ossection.windows" : "Windows OS",
  "softwaresection" : "Software",
  "Version-section": "Version",
  "L2Interface-section": "L2 Interface",
  "IpInterface-section": "IP Interface",
  "SoftwarePatch-section" : "Software Patch",
  "selectOSTitle": "Select Operating System",
  "selectOSAddSWPrompt": "Select an Operating System to add the software",
  "add-os.details": "Add Operating System",
  "add-software.details": "Add Software",
  "generalDesc": "Specify general information about the resource",
  "hardwareDesc": "Specify hardware attributes",
  "osDesc": "Specify operating system attributes",
  "swDesc": "Specify installed software attributes",
  "historyDesc": "Displays lab resource's past activities",
  "reservationDesc": "Displays lab resource's reservations and availability",
  
  "none": "none",
  "noValue": "Not Set",
  
  //Search Messages
  "srchSelectResouceDesc": "Select Lab Resource Description",
  "srchTestDataNotNeeded": "Test Data - Not needed",
  
  //Advanced Search Messages
  "attributesNotShowing" : "Hide Attributes",
  "attributeShowing" : "Show Attributes",
  
  "Software" : "Software",
  "vmsection" : "Virtual Machine",
  "Virtual Machine" : "Virtual Machine",
  "Search" : "Search",
  "editparms" : "Edit Attributes",
  
  // Audit Trail messages
  "AUDITTRAIL_ADD": "Add ${0}",
  "AUDITTRAIL_EDIT": "Edit ${0}", 
  "AUDITTRAIL_REMOVE": "Remove ${0}", 
  "AUDITTRAIL_DISCOVER": "Discover ${0}", 
  "AUDITTRAIL_JOB": "Job ${0}", 
  "AUDITTRAIL_ADD_RESERVATION": "Add Reservation ${0}", 
  "AUDITTRAIL_CANCEL_RESERVATION": "Cancel Reservation ${0}", 
  "AUDITTRAIL_END_RESERVATION": "End Reservation ${0}",
  "AUDITTRAIL_INTEGRATION_NEW": "Import from integration ${0}",
  "AUDITTRAIL_INTEGRATION_UPDATE": "Update from integration ${0}",
  
  // configuration messages
  "description": "Description:",
  "Configuration" : "Test Environment",															// CML: term
  "newConfiguration" : " Create Test Environment",												// CML: term
  "savingConfig" : "Saving the Test Environment...",											// CML: term
  "configConfirmDelete" : "The %1 Test Environment(s) will be removed permanently. Continue?",		// CML: term
  "configDiscardNew" : "Your changes will be discarded. Continue?",
  "configConfirmRemovePart" : "The Lab Resource description will be removed from the Test Environment. Continue?",	// CML: term
  "configCantRemoveLastDescriptor" : "Cannot remove - The Test Environment must contain at least one Lab Resource Description",
  "discardingConfig" : "Deleting the Test Environment...",										// CML: term
  "saveConfigSuccess" : "Test Environment saved successfully.",									// CML: term	
  "configOpFailed" : "Error occurred. Unable to perform the operation on the Test Environment",	// CML: term
  "configOpFailedStaleData" : "Error occurred. Cannot save the Test Environment because it was edited by another user.",	// CML: term
  "fetchConfigFailed" : "Unable to get information about the Test Environment.",				// CML: term
  "createRequestAction" : "Create Request",
  "searchAssetAction" : "Search",
  "configDeleteResourceDescription": "Delete Lab Resource Description",
  "configCoverageSummary": "Coverage",
  "configPropsAtAGlance": "See, at a glance, common properties of each Lab Resource Description",
  "configDescription":"Enter a summary for the Test Environment",
  
  "Log": "Log",			// CML: term - test log???
  "jobLog": "Job Log",
  
  // collections messages
  "labelOpenClose": "Open or Close Pane",
  "labelVirtualCollectionsHelp": "Virtual Collections Help",
  "labelAllVirtualCollections": "All Virtual Collections",
  "labelAllVirtualImages": "Virtual Image Collections",
  "labelAllVirtualMachines": "Virtual Machine Collections",
  "labelHeaderCollectionName": "Collection Name",
  "labelNoResinCollection": "No lab resource in the collection",
  "labelAssignConfig": "Assign Test Environment...",									// CML: term
  "labelDeployingVICollection": "Deploying virtual image Test Cell...",
  "labelUndeployingVMCollection": "Un-deploying virtual machine Test Cell...",
  "msgSettingConfig": "Setting Collection Configuration...",
  "msgDeployedVICollections": "Submitted %1 of %2 deploy virtual image Test Cell requests.",
  "msgUndeployedVMCollections": "Submitted %1 of %2 un-deploy virtual machine Test Cell requests.",
  "msgDeployedTestCell": "Successfully submitted deploy virtual image Test Cell request",
  "msgUndeployedTestCell": "Successfully submitted un-deploy virtual machine Test Cell request",
  "msgErrDeployedTestCell": "Submit deploy virtual image Test Cell request failed",
  "msgErrUndeployedTestCell": "Submit un-deploy virtual machine Test Cell request failed",
  "errRetrieveAllConfigs": "Unable to retrieve all available Test Environments.",		// CML: term
  "errSetCollectionConfig": "Unable assign the Test Environment to the collection.",	// CML: term

  // resource group messages
  "labelNewGroupTitlePrompt" : "&lt; Enter New Lab Resource Group Name &gt; ",
  "labelGroupTitle": "Lab Resource Group &lt;%1&gt;",
  "labelGroupType": "Lab Resource Group",
  "labelListLabResources": "Lab Resources: ",
  "labelRequiredGroupName": "Name: *",
  "labelRequiredTeamArea": "Team Area: *",
  "labelTeamArea": "Team Area:",
  "labelDescription": "Description:",
  "labelStartDate": "Start Date:",
  "labelExpirationDate": "Expiration Date:",
  "labelNeverExpire": "No Expiration",
  "labelGeneralInfo": "General Information",
  "labelGroupAssets": "Lab Resources",
  "labelReleaseFromGroup": "Remove from Group",
  "labelReleasingAssets": "Releasing lab resource...",
  "labelAssetName": "Lab Resource Name",
  "labelOS": "Operating System",
  "labelMfrOrType": "Manufacturer/Type",
  "labelAssetType": "Lab Resource Type",
  "labelHeaderGroupName": "Group Name",
  "labelHeaderDescription": "Description",
  "labelHeaderStartDate": "Start Date",
  "labelHeaderExpirationDate": "Expiration Date",
  "labelHeaderTeamArea": "Team Area",
  "labelMyGroups": "My Groups",
  "labelAllGroups": "All Groups",
  "labelAddToGroup": "Add to group",
  "labelLabResources": "Lab Resources",
  "labelSelectGroup": "Select Group",
  "labelNotApplicable": "n/a",
  "magNoGroupForUser": "The logged in user does not belong to any lab resource group.",
  "msgAssetsNumberInGroup": "Lab resources in this group: %1",
  "msgNoAssetInGroup": "No lab resources in this group",
  "msgAssetsAdded": "%1 lab resources added",
  "msgAssetsRemoved": "%1 lab resources removed",
  "msgInvalidStartDate": "The specified start date is invalid.",
  "msgInvalidEndDate": "The specified expiration date is invalid.",
  "msgInvalidStartEndDates": "The specified start and expiration date combination is invalid.",
  "msgMissingGroupName": "The group name must be specified.",
  "msgMissingTeamArea": "The team area must be specified.",
  "msgSaveGroupSuccess": "The lab resource group is saved successfully",
  "msgReleaseAssetsSuccess": "Selected lab resource are released back to the default pool successfully.",
  "msgRemovingGroups": "Deleting lab resource group %1...",
  "msgRemoveOneGroupSuccess": "Lab resource group deleted successfully.",
  "msgRemoveGroupsSuccess": "Deleted %1 of %2 lab resource group(s) successfully.",
  "msgGroupDeleted": "The lab resource group of this editor has been deleted",
  "msgAddAssetsSuccess": "Selected lab resources have been added successfully.",
  "errLoadGroupInfo": "Failed to load lab resource group information.",
  "errLoadAssetInfo": "Failed to load lab resource information of the group.",
  "errSavingGroup": "Failed to save the lab resource group.",
  "errRefreshingGroupList": "Failed to refresh the lab resource group list.",
  "errReleaseAssets": "Failed to release the selected lab resource.",
  "errAddAssets": "Failed to add the selected lab resources.",  
  "errRemoveGroup": "Failed to Delete the lab resource group.",
  "confirmReleaseResource": "Are you sure you want to release the selected lab resource?",
  "confirmReleaseResourceTitle": "Release Lab resource Confirmation",
  "confirmRemoveGroup": "The selected %1 lab resource group(s) will be deleted! Continue?",
  "confirmRemoveGroupTitle": "Delete Group Confirmation",
  "confirmReleaseResourceFromGroup": "Are you sure you want to release the lab resource from its group?",
  "msgSaveNewGroupBeforeAddingAssets" : "Please save the new group before adding lab resource to it.",
  "msgSpecifyName": "A name must be specified for the %1",
  "msgCPULimit": "Warning the number of machine CPUs (%1) has exceeded the licensed limit of %2.  Contact your system administrator to purchase more licenses",
  
  "NoLogAvailable": "Log is not available",			// CML: term - test log ???
  
  "Availability" : "Availability",
  "includeAssetLabel" : "Include asset group in search? ",
  "ClearAttributes": "Clear",
  "AssetTypeLabel" : "Lab Resource Type:",
  "NoLRDSelected": "&lt; No lab resource description selected &gt;",
  "AllMachines": "All Machines",
  "AllVIs": "All Virtual Images",
  "Today": "Today",
  "Tomorrow": "Tomorrow",
  "Next2Days": "Next two days",
  "Next5Days": "Next five days",
  "SearchResults": "Search Results",
  "AdvancedSearch": "Advanced Search",
  "ViewLabResources": "View Lab Resources",
  "SearchCriteria": "Search Criteria",
  "Synchronize": "Synchronize",
  "Discover": "Discover",
  "Refresh": "Refresh",
  "Virtual Machine Status": "Status",
  "VirtualImages": "Virtual Image(s)",
  "Date": "Date",
  "Inventory Operations": "Inventory Operations",
  "Deployment Operations": "Deployment Operations",
  "Operation": "Operation",
  "Machine Name": "Machine Name",
  "Machine Status": "Machine Status",
  "Provider": "Provider",
  "Configure Automation": "Configure Automation",
  "Deploy Image(s)": "Deploy Image(s)",
  "Virtual Image": "Virtual Image",
  "Hardware": "Hardware",
  "Automation": "Automation",
  "Start Time": "Start Time",
  "End Time": "End Time",
  "Provider Instance": "Provider Instance",
  "undefined": "undefined",
  "automateFetchMachinesError" : "Unable to get machine list.",
  "noAutomationPermissions": "No Permissions to Run Automation",
  "noAutomationPermissionsDetails": "<b>Details:<\/b><br>Your assigned role does not give you permissions to run automations on any lab resources.",
  "noAssetDiscovered": "No assets updated",
  "inventoryAssetAdded": "Asset Added",
  "inventoryAssetUpdated": "Asset Updated",
  "noAutomationsForMachine": "The machine is not configured for automations.",
  "errFetchAutomationsForMachine": "Unable to fetch automation information about the machine. The following error occurred.<br><br>%1",
  "errFetchDiscoverForMachine": "Unable to fetch discovery information about the machine. The following error occurred.<br><br>%1",
    
  "Cancel": "Cancel",
  "ErrorRetrievingLog": "Error Retrieving Log",			// CML: term - test log???
  "nonDiscoverableAsset": "Discovery not available for resource %1",
  "Provider Instance": "Provider Instance",
  
  "ErrorRetrievingLog": "Error Retrieving Log",			// CML: term - test log???
  "nonDiscoverableAsset": "Discovery not available for resource %1",
  "resourceNotFound": "Either job \"%2\" or one of selected machines could not be found on \"%1\"",
  "providerConnectedError": "Unable to connect with \"%1\"",
  "providerAuthError": "Unable to authenticate with \"%1\"",
  "deployOperationsNotAvailable": "%1 operations not available for resource %2",
  "Deploy": "Deploy",
  "Undeploy": "Un-deploy",
  "vmmachines": "Virtual Machine(s)",
  "inventoryNoPerms": "No Permissions to perform actions",
  "inventoryNoPermsDetails": "<b>Details:<\/b><br>Your assigned role does not give you permissions to perform inventory action(s).",
  "labelAutoRefreshDeployView": "Automatically refresh the deployment operations",
  
  "labelPort": "Port (Optional):",
  "labelUserName": "User Name:",
  "labelPassword": "Password:",
  "labelProvider": "Provider:",
  "fetchingInventoryProviders": "Getting inventory providers information...",
  "msgBFNeedInputs" : "Please enter the User Name/Password and the Temp Path value.",
  "msgNoInventoryProvider" : "No providers having inventory capability found. Cannot add to provider at the moment.",
  "errGetInventoryProviders" : "Unable to get inventory providers information. Cannot add to provider at the moment.",
  "labelTempPath": "Temp Path:",
  "Save": "Save",
  "Saving": "Saving to provider...",
  "Add to provider": "Add to provider",
  "General Info": "General Information",
  
  "savedBldFrgSuccessMsg": "Lab resource successfully added to provider",
  "savedBldFrgFailureMsg": "Failed adding lab resource to provider",
  
  //SPI Error Codes
  "SPIRC_SAVE_ASSET_ERROR": "Failed saving the lab resource to RQM database",
  "SPIRC_ASSET_RETRIEVE_ERROR": "The lab resource has been deleted in RQM by another user",
  "SPIRC_EXTENSION_POINT_IMPLEMENTATION_ERROR": "Service provider not accessible",
  "SPIRC_PROVIDER_CONNECTION_ERROR": "Unable to connect with external provider server",
  "SPIRC_PROVIDER_CONNECTION_AUTH_ERROR": "Unable to authenticate with external provider server",
  "SPIRC_PROVIDER_RETRIEVE_ERROR": "Unable to find provider, %1",
  "SPIRC_PROVIDER_ABILITY_ERROR": "The provider is incapable of inventory services",
  "SPIRC_PROVIDER_INTERNAL_ERROR": "An internal error has occurred within provider server, please see server log for more details",
  "SPIRC_PROVIDER_AGENT_UNREACHABLE": "The lab resource is unreachable via the selected provider. Please check the arguments entered and try again.",
  "SPIRC_INVENTORY_PROVIDER_NOT_CONFIG_ERROR": "No inventory provider available",
  "SPIRC_VIRTUALIZATION_PROVIDER_NOT_CONFIG_ERROR": "No virtualization provider available",
  "SPIRC_ADD_ASSET_TO_PROVIDER_NOT_SUPPORT": "The selected provider does not support having lab resources added from RQM",
  "SPIRC_DELETE_ASSET_ON_PROVIDER_NOT_SUPPORT": "Lab resource deleted, but delete is not supported by inventory and automation integrations",
  "SPIRC_ASSET_DELETED_FOR_MULTIPLE_PROVIDERS_FAILED": "Lab resource deleted, but there were errors deleting from inventory and automation integrations. See the server error log for more details", 
  
  //Deploy and undeploy Error Codes
  "SPIRC_REQUEST_NOT_IMPLEMENTED": "The provider adapter not support the request",
  "SPIRC_BAD_REQUEST_ERROR": "Invalid request for provider adapter",
  "SPIRC_RESOURCE_NOT_FOUND": "Lab resource not found on external provide server",
  "SPIRC_DEPLOY_VI_EXTERNAL_ERROR": "An internal error has occurred within provider server when deploying the virtual image",
  "SPIRC_DEPLOY_VIC_EXTERNAL_ERROR": "An internal error has occurred within provider server when deploying the virtual image collection",
  "SPIRC_UNDEPLOY_VM_EXTERNAL_ERROR": "An internal error has occurred within provider server when un-deploying the virtual machine",
  "SPIRC_UNDEPLOY_VMC_EXTERNAL_ERROR": "An internal error has occurred within provider server when un-deploying the virtual machine collection",
  "SPIRC_RESOURCE_NOT_FOUND": "Lab resource is not available for the requested operation",
  
  // Automation in RTLM Error Codes
  "SPIRC_MACHINE_NOT_IN_MAPPING": "The machine is not managed by \"%1\"",
  
  //Inventory history page messages
  "msgDeployedVIs": "Succeed to submit %1 of %2 deploy virtual image request",
  "msgUndeployedVMs": "Succeed to submit %1 of %2 deploy virtual image request",
  "msgSyncInventoryProviderConfigured": "Synchronized inventory providers",
  "msgSyncVirtualizationProviderConfigured": "Synchronized virtualization providers",
  "msgSyncBothProvidersConfigured": "Synchronized inventory and virtualization providers",
  "warnSyncNoProviderConfigured": "No inventory or virtualization provider available",
  
  "labelNew": "New",
  "labelDetail": "Detail",
  "labelManager": "Manager",
  "labelHelp": "%1 %2 Help",
  
  "labelTableSummary": "This is %1 table",
  "labelAsset": "Asset",
  "labelReservedMachine": "Reserved Machines",
  "labelFoundMachine": "Found Machines",
  "labelOfflineMachines": "Offline Machines",
  "labelQueryResult": "Query Result",
  
  "Discover Image(s)": "Discover Machine(s)",
  "machineDiscoverDisabled": "One of the machines selected is not discoverable.  Discovery disabled. For more information see the help topic: Discovering and importing Tivoli Provisioning Manager data into Rational Quality Manager.",
  
  "Asset New": "New Asset",
  "Asset Update" : "Update Asset",
  "Discover Error": "Discovery Error",
  "Asset Remove": "Asset Removed",
  "labelFile": "File:",
  
  "msgConfirmRemoveLMSection": "Are you sure you want to remove the section?",
  "msgConfirmRemoveResourceDescription": "Are you sure you want to remove the resource description?",
  "msgConfirmRemoveAttribute": "Are you sure you want to remove the %1 attribute?",
  "titleSelectAtributes": "Select Attributes To Show",
  
  "RequestID": "Request ID: ",
  "labelInventory": "Inventory",
  "labelAutomations": "Automations",
  "labelAutomationToRun": "Available Automations to Run",
  "labelRunningAutomations": "Running Automations",
  "labelAvailMachForAutomation": "Available Machines for Automations",
  
  "labelRelatedSites": "Related Sites",
  "productBuildForge": "Build Forge",
  "productVMLogix": "VMLogix",
  "productTSRM": "Tivoli - TSRM",
  "productTADDM": "Tivoli - TADDM",

  "pageTitleAsset": "%1: %2",   // %1 = the label for the type of asset, %2 = the asset's display name
  "pageTitleRequest": "Request: %1", 
  "pageTitleAssetGroup": "Lab Resource Group: %1",
  "pageTitleTestEnvironment": "Test Environment: %1",
  "pageTitleTestCell": "Test Cell: %1",
  
  "labelNone": "None",
  "cellNewPrompt" : "&lt; Enter New Test Cell Name &gt;",						// CML: term
  "cellLabel" : "Test Cell",
  "cellSummary" : "Summary",
  "cellDescription": "Description",
  "cellDescriptionPrompt":"Enter a description of the Test Cell",
  "cellRequireNameError": "You must enter a name for the Test Cell.",		// CML: term
  "cellEnvironmentSection" : "Lab Resources",
  "cellEnvironmentPrompt" : "Add Lab Resources to the Test Cell and associate the Lab Resources to Lab Resource Descriptions",
  "cellAvailabilitySection" : "Machine Availability",
  "cellAvailabilityPrompt" : "See and update the reservation status of the machines in the Test Cell",
  "cellLRDName" : "Lab Resource Description",
  "cellResourceName" : "Resource Name",
  "cellAvailability" : "Availability",
  "cellTestEnvironment" : "Test Environment:",
  "cellSelectEnv" : "Select a Test Environment for the Test Cell",
  "cellClearEnv" : "Clear the reference to a Test Environment",
  "cellAddRow" : "Add Row",
  "cellRemoveRow" : "Remove Row",
  "cellConfirmRemoveRow" : "Are you sure you want to remove the row from the cell?",
  "cellConfirmRemoveRowTitle" : "Remove Row Confirmation",
  "cellConfirmRemove" : "Are you sure you want to delete the selected %1 %2?",
  "cellConfirmRemoveTitle" : "Delete Test Cell Confirmation",
  "cellNoEnvironment" : "None Selected",
  "cellNote" : "Note",
  "cellAddMissingCoverage" : "Cover all Lab Resource Descriptions",
  "cellNotAllCovered" : "%1 of %2 Lab Resource Descriptions covered",
  "cellAllCovered" : "All Lab Resource Descriptions covered",
  "labelAllTestCells": "All Test Cells",
  "labelAllTestCellsHelp": "All Test Cells Help",
  "cellAssetTypeLabel": "Type:",
  "cellKnownAssetTypeLabel": "Type: %1",
  "cellFindMachine": "Find a Lab Resource for the selected row",
  "cellAssignMachines": "Assign a Lab Resource to each row (if possible)",
  "cellOwner": "Owner",
  "cellType": "Type",
  "createTestCellAction": "Create Test Cell",
  "cellCells" : "Test Cells",
  "fetchCellFailed": "Unable to load the Test Cell",
  "savingTestCell" : "Saving Test Cell...",
  "errLoadingTestCells" : "Error Loading Test Cells",
  "errSavingTestCell" : "Error Saving Test Cell",
  "cellSelectFrom" : "Select from:"
})
