/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
({
 "labelUnknwonDefectsProvider": "Unknwon DefectsProvider %1",
 "labelDefectsProviderNotInitialized": "DefectsProvider %1 is not initialized",
 "labelLoadDefectsProviderConfiguration": "Load Defects Provider Configuration",
 "labelInitializeDefectsProviders": "Initialize Defects Providers",
 "labelFoundDuplicateDefectsProvider": "Found duplicate implementations for DefectsProvider with id %1",
 "labelFountUnknownDefectsProvider": "Found implementation for unknown DefectsProvider with id %1",
 "labelNoCreateDefect": "The DefectsProvider %1 does not implement createDefect",
 "labelNoDeleteDefect": "The DefectsProvider %1 does not implement deleteDefect",
 "labelNoQueryExistingDefects": "The DefectsProvider %1 does not implement queryExistingDefects",
 "labelNoQueryAssociatedDefects": "The DefectsProvider %1 does not implement queryAssociatedDefects",
 "labelNoAssociateDefect": "The DefectsProvider %1 does not implement associateDefect",
 "labelNoUnassociateDefect": "The DefectsProvider %1 does not implement unassociateDefect",
 "labelBack": "< Back",
 "labelNext": "Next >",
 "labelNoGetContentNode": "This WizardPage does not implement getContentNode",
 "labelUnableOpenDefect": "Unable to open the defect in a new window. " + 
						 "This may be caused by the presence of a pop-up blocker; " + 
						 "Disable the software used to block pop-up windows for this website and click " + 
						 "<a href=\"%1\" target=\"%2\">here<\/a>.",
 "labelOpen": "Open",
 "labelClose": "Close",
 "labelCancel": "Cancel",
 "labelFinish": "Finish",
 "labelId": "Id",
 "labelSummary": "Summary",
 "labelAssociatedDefect": "Associated Defect (Summary not yet replicated)",
 "_labelEnterSearchString": "Use Work Item ID or Words from the Summary",
 "_labelButtonOK": "OK",
 "_labelButtonCancel": "Cancel",
 "labelAssociatedDefects": "Associated Defects",
 "labelLoadAssociatedDefects": "Loading Associated Defects",
 "labelRunningSearch": "Running search...",
 "labelMatchingWorkItems": "Matching Work Items:",
 "labelWorkitemResult": "%1 results",
 "labelErrorRunningQuery": "Error running query",
 "labelWorkitemLinked": "This work item is already linked.",
 "labelPlanItemSelectionPicker": "Plan Item",
 "labelPlanItemSelectionPickerTitle": "Select the plan item",
 "labelPlanItemCreationPickerTitle": "Create a new plan item",
 "labelSuspectHeading": "Suspect",
 "labelSummaryHeading": "Summary",
 "labelWorkItemId": "ID",
 "labelCreateNewWorkitem": "Create a new plan item",
 "labelAddNewWorkitem": "Add plan items",
 "labelRemoveWorkitem": "Remove plan items",
 "labelInitializingDialog": "Initializing change management provider",
 "labelServiceProviderTitle": "Provider selection",
 "labelSelectServiceProvider": "More than one provider is configured, please select the one you want to connect with",
 "labelRefreshRmLinks": "Refresh links",
 "labelAddRmLinks": "Add new links",
 "labelRemoveRmLinks": "Remove links",
 "labelReqSelectionPicker": "Requirement links",
 "labelReqSelectionPickerTitle": "Add requirement links",
	
 "msgLinkgWithTeamConcert": "Linking with external change management providers",
 "msgPostingWorkItemLink": "Creating a Link in Plan Item %1",
 "msgDeletingWorkItemLink": "Deleting Link from Plan Item %1",
 "msgPostingLocalLinks": "Creating Links in RQM",
 "msgDeletingLocalLinks": "Deleting Links in RQM",
 "msgAboutToInitializeProvider": "About to initialize the connection with external providers, please be patient!",
 "msgDiscoverURIs": "Initializing connection with selected provider...",
 "msgDiscoverProvider": "Initializing connection with providers",
 "msgFailedToConfigProvider": "The following problems occurred during the initialization process: \n %1 ",
 "msgNoneCMProvidersConfigured": "No change management provider configured, please consult your administrator for more details!",
 "msgPopupBlockedOrCanceled": "To complete this operation, your browser must accept pop-up windows and must not be dismissed. Configure your browser to accept pop-up windows and try the operation again.",
 "msgService500": "The following server error occurred when connecting to the external provider. Please check with your administrator and try again later.\n %1 ",
 "msgNoneRMProvidersConfigured": "No requirement management provider configured, please consult your administrator for more details!",
 "msgUpdatingRmLinks": "Updating requirement links",
 "msgUpdateBackLinks": "Updating back links in requirement resource",
 "msgUpdateLocalLinks": "Updating requirement links in testing resource",
 "msgCreatingTestCase": "Creating test case for requirements",
 "msgLinkingTestCase": "Linking test case for requirement: %1",
 "msgAddingTestCase": "Adding test cases into current test plan"
})
