/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
(function()
{	
	var ImageCache = dojo.provide("com.ibm.rqm.process.web.ui.internal.view.approval.ImageCache");

	ImageCache._BASE= dojo.moduleUrl("com.ibm.rqm.process.web", "ui/internal/view/templates/approval/images/").toString();

	ImageCache._getImageUri = function(imgName)
	{
		return ImageCache._BASE + imgName;
	};
	
	ImageCache.getTypeIconURL = function(/* SimpleExtensionType */ type)
	{
		var icon = type.icon;	
		var iconImage = icon != null ? icon.substring(icon.lastIndexOf("/") + 1) : "";
		return ImageCache._BASE + iconImage;
	};
	
	ImageCache.LESS     = ImageCache._getImageUri("arrow-less.gif");
	ImageCache.MORE    = ImageCache._getImageUri("arrow-more.gif");
	ImageCache.APPROVER    = ImageCache._getImageUri("approver.gif");
	ImageCache.REVIEWER    = ImageCache._getImageUri("reviewer.gif");
	ImageCache.APPROVED = ImageCache._getImageUri("approved.gif");
	ImageCache.PENDING = ImageCache._getImageUri("pending.gif");
	ImageCache.NO_APPROVED = ImageCache._getImageUri("no_approved.gif");
}
)();
