/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.planning.web.ui.internal.view.construction.ConstructionCommands");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.ConstructionCommands");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");

(function() { // module container

var Utility				    = com.ibm.rqm.planning.web.ui.internal.util.Utility;

var MY_TEST_CASE_GROUPS = "My Test Case Groups";
var MY_TEST_CASES = "My Test Cases";
var STR_CREATE_TEST_GROUP  = "New Test Case Group";
var STR_CREATE_TEST_CASE   = "New Test Case";

dojo.declare(
	"com.ibm.rqm.planning.web.ui.internal.view.construction.ConstructionCommands",
	[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/ConstructionCommands.html"),
//		templateCssPath: dojo.uri.dojoUri("../com.ibm.rqm.planning.web/ui/internal/view/templates/construction/ConstructionCommands.css"),
		
		// object initializer
		constructor: function() {
		},
		
		// populate the template with data, connect events, and show initial
		// sub-tab
		postCreate: function() { //args, frag) {
//			if (args.parentController === null) {
//				throw new Error("ConstructionCommands#postCreate: Missing required parameter 'args.parentController'");
//			}
//			this.parentController = args.parentController;
			this._newTestScriptLink.href = Utility.getNewTestScriptURI("", Utility.CONSTRUCTION_PERSPECTIVE);						
			this._importScriptLink.href = Utility.getImportScriptURI("Import Rational Functional Tester Scripts", Utility.CONSTRUCTION_PERSPECTIVE);
		},	
		
		_error: function(errorObj) {
			alert("Error: (message: '" + errorObj.message + "') in ConstructionCommands#_error");
		}
	}
);

})();
