/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.viewlets.QMStatisticsViewlet");

dojo.require("com.ibm.team.workitem.viewlets.web.ui.internal.StatisticsViewlet");

(function() {

//This would not be needed if the _isVisible of com.ibm.team.workitem.viewlets.web.ui.internal.StatisticsViewlet
//worked properly instead of looking for dashboard in the url.

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.viewlets.QMStatisticsViewlet",	
	com.ibm.team.workitem.viewlets.web.ui.internal.StatisticsViewlet,
{
	/*
 	 * Private Method
 	 * 
 	 * Temporary fix until ViewletSite.isActive() is fixed
 	 * 
 	 * @param void
 	 * @return boolean
 	 */		
	_isVisible: function() {
		//The jazz statistics viewlet does something stupid by looking at url to see if something
		//is visible.  This overrides that method.
		// Ensure the viewlet's page is visible
		if (this.getSite()._container.viewletPage.dashboardContainer.getCurrentPage() != 
			this.getSite()._container.viewletPage) {
			return false;
		}
		return true;
	}
	
});

})();
