/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.appscan.web.ui.internal.view.viewlets.SecurityTrainingViewlet");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.ProgressBar");
dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.asq.common.web.ui.internal.view.viewlets.AbstractViewlet");
dojo.require("com.ibm.rqm.planning.web.ui.internal.model.SaveContext");


(function()
{
//var Utility					= com.ibm.rqm.planning.web.ui.internal.util.Utility;
var ImageCache				= null;
var SaveContext				= com.ibm.rqm.planning.web.ui.internal.view.common.SaveContext;
var Viewlet 				= com.ibm.team.dashboard.web.ui.Viewlet;
var ServiceResponseHandler	= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var AbstractViewlet = com.ibm.asq.common.web.ui.internal.view.viewlets.AbstractViewlet;

var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	
dojo.declare("com.ibm.rqm.appscan.web.ui.internal.view.viewlets.SecurityTrainingViewlet",	AbstractViewlet,
{
	templatePath: dojo.moduleUrl("com.ibm.rqm.appscan.web", "ui/internal/view/templates/viewlets/SecurityTrainingViewlet.html"),
    init: function() {
		ImageCache = com.ibm.rqm.appscan.web.ui.internal.view.common.ImageCache;
	},    
	refresh: function()
	{
		var bar = new dijit.ProgressBar({'class' : 'smallred'});
		bar.update({maximum: 100, progress: 90});
		this._progressA.appendChild(bar.domNode);
			
		bar = new dijit.ProgressBar({'class' : 'smallred'});
		bar.update({maximum: 100, progress: 10});
		this._progressB.appendChild(bar.domNode);
		
		bar = new dijit.ProgressBar({'class' : 'smallred'});
		bar.update({maximum: 100, progress: 30});
		this._progressC.appendChild(bar.domNode);
	
		this._hasZoomableContent = true;
		this.getSite().setLoading(true);
		
		this._lockImgA.src = ImageCache.LOCK;
		this._lockImgB.src = ImageCache.LOCK;
		this._lockImgC.src = ImageCache.LOCK;

		this._newWindowImg.src = ImageCache.NEWWINDOW;
//		var loading = document.createElement("div");
//		loading.innerHTML = "Loading...";
//		loading.className = "loadingText";
//		this._contentArea.appendChild(loading);

		this.update();
	},

	update: function()
	{
		
	//	this._progress.update({maximum: 100, progress: 50});
		//dojox.data.dom.removeChildren(this._contentArea);
//
//		SaveContext.init();
//
//		this.editor = new com.ibm.rqm.planning.web.ui.internal.view.construction.TestScriptEditor();
//		this._contentArea.appendChild(this.editor.domNode);
//		this.editor.initialize({ parentController: this, testScript: this._testScript });
//			
//		SaveContext.addParticipant(this.editor);

		this.getSite().setLoading(false);
	},
	
	_error: function(errorObj)
	{
		console.error("Error getting data (message: '" + errorObj.message + "') in SecurityTrainingViewlet#_error");
	},
	
	hasZoomableContent: function() {
//		if (this._count && this._count > 10)
			return true;
//		return false;
	},
	
	settingsChanged: function(oldSettings, newSettings) {
		alert("in settingsChanged function");
/*		if (newSettings.scope != oldSettings.scope || newSettings.scopeItemId != oldSettings.scopeItemId ||
			(newSettings.scope == DashboardConstants.SCOPE_TEAM_AREA && newSettings.scopeSubteams != oldSettings.scopeSubteams))
			this.refresh();
		else
			this.update();
*/
	}
});

})();
