/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.requests.ReservationsUriUtil");
(function() {


var BaseActionHref = "#action=com.ibm.rational.test.lm.web.ui.internal.views.requests.ReservationsPage.";

// Summary:
//    Utility object to compose URIs for reservations page's actions.
//
com.ibm.rational.test.lm.web.ui.internal.views.reservations.ResrvationsUriUtil = 
{

    // Summary:
    //    Creates the URI to forward to the new reservation view.  
    //        
    getNewReservationURI: function()
    {
        var timestamp = dojo.date.locale.format(new Date(), {selector:"time", timePattern:"hh:mm:ss"});
         return BaseActionHref + "newReservationView" + "&id=" + timestamp;
    }
};
})();
