/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.defects.web.ui.utils.WindowUtil");

dojo.require("com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil");

(function() {

dojo.mixin(com.ibm.rqm.defects.web.ui.utils.WindowUtil, {

	openArtifactInNewWindow: function(url, windowId) {
		windowId= windowId || "_blank"
		var otherWindow= window.open(url, windowId);
		if (otherWindow != null) {
			otherWindow.focus();
		} else {
			// a popup blocker prevented us from opening the window.
			
			var props = {
				title: "Unable to open defect in a a new window",
	          	style: "position: absolute; top: 20%; left: 40%; width: 450px; height: 125px;"
	       	};
					
			var dialogContent = document.createElement("div");
			dialogContent.innerHTML=  com.ibm.rqm.defects.web.ui.utils.DefectsUIUtil.getMessage("labelUnableOpenDefect", url, windowId);	

	        this.dialog = new dijit.Dialog(props, dialogContent);
			this.dialog.show();
		}
	},

	__sentinel: null // terminates this class definition
});

})();
